K Best(最大化平均数)_二分搜索

Description

Demy has n jewels. Each of her jewels has some value vi and weight wi.

Since her husband John got broke after recent financial crises, Demy has decided to sell some jewels. She has decided that she would keep k best jewels for herself. She decided to keep such jewels that their specific value is as large as possible. That is, denote the specific value of some set of jewels S = {i1i2, …, ik} as

.

Demy would like to select such k jewels that their specific value is maximal possible. Help her to do so.

Input

The first line of the input file contains n — the number of jewels Demy got, and k — the number of jewels she would like to keep (1 ≤ k ≤ n ≤ 100 000).

The following n lines contain two integer numbers each — vi and wi (0 ≤ vi ≤ 106, 1 ≤ wi ≤ 106, both the sum of all vi and the sum of all wi do not exceed 107).

Output

Output k numbers — the numbers of jewels Demy must keep. If there are several solutions, output any one.

Sample Input

3 2
1 1
1 2
1 3

Sample Output

1 2

【题意】有n个物品的重量和价值分别是w[i]和v[i],从中选出K个物品使得单位重量的价值最大。

1<=k<=n<=10^5

1<=w[i],v[i]<=10^7

【思路】一般想到的是按单位价值对物品排序,然后贪心选取,但是这个方法是错误的,对于有样例不满足。

我们一般用二分搜索来做(其实这就是一个01分数规划)

我们定义:

条件 C(x) =可以选k个物品使得单位重量的价值不小于x。

因此原问题转换成了求解满足条件C(x)的最大x。那么怎么判断C(x)是否满足?

变形:(SUM(v[i])/SUM(w[i]))>=x (i 属于我们选择的某个物品集合S)

进一步:SUM(v[i]-x*w[i])>=0

于是:条件满足等价于选最大的k个和不小于0.于是排序贪心选择可以判断,每次判断的复杂度是O(nlogn)。

参考链接:http://www.2cto.com/kf/201308/235786.html

#include<iostream>
#include<stdio.h>
#include<string.h>
#include<algorithm>
using namespace std;
const int inf=0x3f3f3f3f;
const int N=100010;
struct node
{
    double w,v,ret;
    int id;
}a[N];
int n,k;
bool cmp(node a,node b)
{
    return a.ret>b.ret;
}
bool ok(double mid)//是否满足条件SUM(v[i]-x*w[i])>=0
{
    double sum=0;
    for(int i=1;i<=n;i++)
    {
        a[i].ret=a[i].v-mid*a[i].w;
    }
    sort(a+1,a+1+n,cmp);
    for(int i=1;i<=k;i++)
    {
        sum+=a[i].ret;
    }
    return sum>=0;
}
int main()
{
   while(~scanf("%d%d",&n,&k))
    {
        for(int i=1;i<=n;i++)
        {
            scanf("%lf%lf",&a[i].v,&a[i].w);
            a[i].id=i;
        }
         double l=0,r=1.0*inf;
        while(r-l>1e-5)//二分搜索
        {
            double mid=(l+r)/2;
            if(ok(mid))
                l=mid;
            else r=mid;
        }
        for(int i=1;i<k;i++)
        {
            printf("%d ",a[i].id);
        }
        printf("%d\n",a[k].id);

    }
    return 0;
}
时间: 2024-12-05 17:14:05

K Best(最大化平均数)_二分搜索的相关文章

poj 3111 K Best 最大化平均值 二分思想

poj 3111 K Best 最大化平均值 二分思想 题目链接: http://poj.org/problem?id=3111 思路: 挑战程序竞赛书上讲的很好,下面的解释也基本来源于此书 设定条件C(x):=可以选择使得单位重量的价值不小于x 如何判定C(x)是否可行 假设选了某个物品的集合是S,那么单位重量的价值是:\[ \sum\limits_{i \in S} {v_i } /\sum\limits_{i \in S} {w_i } \] 因此就变成了判断是否存在S满足下面的条件:\[

【贪心专题】POJ 2456 Aggressive cows &amp;&amp; NYOJ 586 疯牛(最大化最小值 贪心+二分搜索)

链接: click here~~ 题意:农夫 John 建造了一座很长的畜栏,它包括N (2 <= N <= 100,000)个隔间,这些小隔间依次编号为x1,...,xN (0 <= xi <= 1,000,000,000). 但是,John的C (2 <= C <= N)头牛们并不喜欢这种布局,而且几头牛放在一个隔间里,他们就要发生争斗.为了不让牛互相伤害.John决定自己给牛分配隔间,使任意两头牛之间的最小距离尽可能的大,那么,这个最大的最小距离是什么呢? [解题

【贪心专题】POJ 3258 River Hopscotch (最大化最小值 贪心+二分搜索)

链接:click here~~ [题意] 一条河长度为 L,河的起点(Start)和终点(End)分别有2块石头,S到E的距离就是L,河中有n块石头,每块石头到S都有唯一的距离,,现在要你移除其中的m块,使得具有最小间距的相邻两块石头之间的距离最大. [解题思路] 又是一道经典的二分搜索,跟前一道一样的思路,不过要注意的是:此题是移除其中的元素,从而达到最大化的最小值. 代码: #include <stdio.h> #include <string.h> #include <

POJ 3111 K Best(最大化平均值)

题目链接:click here~~ [题目大意]有n个物品的重量和价值分别是Wi和Vi,从中选出K个物品使得单位重量的价值最大,输出物品的编号 [解题思路]:最大化平均值的经典.参见click here~~ 代码: //#include <bits/stdc++.h> #include <stdio.h> #include <math.h> #include <string.h> #include <iostream> #include <

Python实现K近邻算法&lt;KNN&gt;_分类器

收集数据 数据来源:http://archive.ics.uci.edu/ml/datasets/Haberman%27s+Survival 文本数据如下图所示: 31,65,4,1 33,58,10,1 33,60,0,1 34,59,0,2 34,66,9,2 这是关于乳腺癌已手术患者存活时间(寿命)的样本集,文本文件中共包含306个样本,样本包含的属性有: 1. 患者做手术时的年龄 opAge 2. 患者做手术的年份-1900 opYear,比如1970年做的手术,则opYear属性的值为

51nod 1001_数组中和等于K的数对_二分

题目描述 给出一个整数K和一个无序数组A,A的元素为N个互不相同的整数,找出数组A中所有和等于K的数对.例如K = 8,数组A:{-1,6,5,3,4,2,9,0,8},所有和等于8的数对包括(-1,9),(0,8),(2,6),(3,5). 思路 枚举一个二分一个,很优秀. #include <stdio.h> #include <iostream> #include <string> #include <cstring> #include <alg

HDU 2199 Can you solve this equation?_二分搜索

1 #include <iostream> 2 #include <cstdio> 3 #include <cmath> 4 #define sc(x) scanf("%d",&(x)) 5 #define pf(x) printf("%.4lf\n", x) 6 using namespace std; 7 int T; 8 double Y; 9 double r(double x) 10 { 11 return (8

二分搜索(2、Yougth的最大化,无限逼近最大值)

条件C(x):=可以选择是单位重量的价值不小于x,则该问题就变成了满足C(x)的最大的x,那么怎么判断C(x)是否可行呢?假设我们选了某个物品的集合S,那么它们的单位重量价值是: 因此就变成了判断是否存在s满足下面条件: 把这个不等是进行变形就得到 //#define LOCAL #include<cstdio> //#include<iostream>注意引入头文件,编译时候需要连接,是费内存的,如果不需要尽量不要引入 #include<algorithm> int

51nod 平均数(马拉松14)

平均数 alpq654321 (命题人) 基准时间限制:4 秒 空间限制:131072 KB 分值: 80 LYK有一个长度为n的序列a. 他最近在研究平均数. 他甚至想知道所有区间的平均数,但是区间数目实在太多了. 为了方便起见,你只要告诉他所有区间(n*(n+1)/2个区间)中第k大的平均数就行了. Input 第一行两个数n,k(1<=n<=100000,1<=k<=n*(n+1)/2). 接下来一行n个数表示LYK的区间(1<=ai<=100000). Outp